/*
 * SMBusLib.h
 *
 *  Created on: 23. 11. 2020
 *      Author: Ondra
 */

#ifndef SMBUSLIB_H_
#define SMBUSLIB_H_

//Command BQ40Z80
#define BQ40Z80_Address				0x16//BQ40Z80 slave address
#define BQ40Z80_RSOC				0x0D
#define BQ40Z80_Voltage				0x09
#define BQ40Z80_Current				0x0A
#define battery_status_reg			0x16	//registr battery status
#define battery_status_FC			0x0020 //fully charged mask
#define battery_status_TCA			0x4000 //terminate charge alarm mask

//Commands BQ24725A
#define BQ24725A_Address 			0x12//0x12 //BQ24725A slave address
#define BQ24725A_ChargeCurrent		0x14 //R/W
#define BQ24725A_ChargeVoltage		0x15 //R/W, 1.024V to 19.200V, 16mV step
#define BQ24725A_InputCurrent		0x3F //R/W
#define BQ24725A_ChargeOption		0x12 //R/W
#define BQ24725A_DeviceID			0xFF //R only, returns 0X000B
#define BQ24725A_ManufacturerID		0xFE //R only, returns 0x0040
#define charge_option_charge_inhibit	0x0001	//charge inhibit mask

HAL_StatusTypeDef SMBus_Write_Word(uint8_t address, uint8_t command, uint16_t data);
HAL_StatusTypeDef SMBus_Write_Word_old(uint8_t address, uint8_t command, uint16_t data);//pak umazat
uint16_t SMBus_Read_Word(uint8_t address, uint8_t command);
uint8_t SMBus_Read_Block(uint8_t address, uint8_t command, uint8_t *pData);
HAL_StatusTypeDef SMBus_Write_Block(uint8_t address, uint8_t command, uint8_t *pData, uint8_t data_len);
void BQ40Z80_Flash_Read_Block(uint16_t flashaddr);
void BQ40Z80_Flash_Read_All(void);
void BQ24725A_test(void);


#endif /* SMBUSLIB_H_ */
